"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.constantRouterMap = void 0;

var _vue = _interopRequireDefault(require("vue"));

var _vueRouter = _interopRequireDefault(require("vue-router"));

var _import2 = _interopRequireDefault(require("./_import.js"));

var _Layout = _interopRequireDefault(require("@/view/layout/Layout.vue"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

_vue["default"].use(_vueRouter["default"]);

var constantRouterMap = [{
  path: '/login',
  component: function component() {
    return Promise.resolve().then(function () {
      return _interopRequireWildcard(require('@/view/login/login'));
    });
  },
  name: 'login'
}, {
  path: '/404',
  component: function component() {
    return Promise.resolve().then(function () {
      return _interopRequireWildcard(require('@/view/errorPage/404'));
    });
  },
  name: 'error404'
}, {
  path: '/403',
  component: function component() {
    return Promise.resolve().then(function () {
      return _interopRequireWildcard(require('@/view/errorPage/403'));
    });
  },
  name: 'error403'
}, {
  path: '/500',
  component: function component() {
    return Promise.resolve().then(function () {
      return _interopRequireWildcard(require('@/view/errorPage/500'));
    });
  },
  name: 'error500'
}, {
  path: '/',
  name: 'Layout',
  redirect: '/allCustomers',
  component: _Layout["default"],
  children: [{
    path: '/allCustomers',
    component: (0, _import2["default"])('allCustomers', 'allCustomersList'),
    meta: {
      title: '全部客户',
      keepAlive: true
    }
  }, {
    path: '/customerDetail',
    component: (0, _import2["default"])('allCustomers', 'customerDetail'),
    meta: {
      title: '客户详情'
    }
  }, {
    path: '/consumption',
    component: (0, _import2["default"])('allCustomers', 'consumption'),
    meta: {
      title: '会员门店消费'
    }
  }, {
    path: '/wechattotal',
    component: (0, _import2["default"])('wechatmembers', 'wechat-total'),
    meta: {
      title: '微信总量',
      keepAlive: true
    }
  }, // {
  //   path: "/wechatmembers",
  //   component: _import("wechatmembers", "wechatmembers"),
  //   meta: {
  //     title: "微信会员",
  //     keepAlive: true
  //   }
  // },
  {
    path: '/talkLogPage',
    component: (0, _import2["default"])('wechatmembers', 'talkLogPage'),
    meta: {
      title: '微信会员-通话记录'
    }
  }, {
    path: '/infoMall',
    component: (0, _import2["default"])('wechatmembers', 'infoMall'),
    meta: {
      title: '微信会员-微信商城消费'
    }
  }, // {
  //   path: "/posmembers",
  //   component: _import("posmembers", "posmembers"),
  //   meta: {
  //     title: "pos会员",
  //     keepAlive: true
  //   }
  // },
  {
    path: '/onlinemembers',
    component: (0, _import2["default"])('onlinemembers', 'onlinemembers'),
    meta: {
      title: '电商会员'
    }
  }, {
    path: '/buyermembers',
    component: (0, _import2["default"])('buyermembers', 'buyermembers'),
    meta: {
      title: '电商买家'
    }
  }, {
    path: '/frozenList',
    component: (0, _import2["default"])('wechatmembers', 'frozenList'),
    meta: {
      title: '冻结会员列表'
    }
  }, {
    path: '/frozenList/frozenMember',
    component: (0, _import2["default"])('wechatmembers', 'frozenMember'),
    meta: {
      title: '冻结会员'
    }
  }, {
    path: '/wechatmembers/memberSetting',
    component: (0, _import2["default"])('wechatmembers', 'memberSetting'),
    meta: {
      title: '微信会员-设置'
    }
  }, {
    path: '/labelmanager',
    component: (0, _import2["default"])('labelmanager', 'labelmanager'),
    meta: {
      title: '会员标签'
    }
  }, {
    path: '/member-achievement',
    component: (0, _import2["default"])('achievement', 'achievement'),
    meta: {
      title: '会员成就'
    }
  }, {
    path: '/achievement',
    component: (0, _import2["default"])('achievement', 'achievement'),
    meta: {
      title: '会员成就'
    }
  }, {
    path: '/achievement_interaction',
    component: (0, _import2["default"])('achievement', 'achievement'),
    meta: {
      title: '会员成就'
    }
  }, {
    // 微信会员回收站数据页面
    path: '/memberReturn',
    component: (0, _import2["default"])('memberlist', 'memberReturn'),
    meta: {
      title: '微信会员回收站'
    }
  }, {
    // POS会员回收站数据页面
    path: '/posRecycle',
    component: (0, _import2["default"])('memberlist', 'pos-recycle'),
    meta: {
      title: 'POS会员回收站'
    }
  }, {
    path: '/membergroupAdd',
    component: (0, _import2["default"])('membergroup', 'membergroupAdd'),
    meta: {
      title: '会员分组-新增'
    }
  }, {
    path: '/membergroup',
    component: (0, _import2["default"])('membergroup', 'membergroup'),
    meta: {
      title: '会员分组'
    }
  }, {
    path: '/cardvoucher',
    component: (0, _import2["default"])('wechatmembers', 'cardvoucher'),
    meta: {
      title: '微信会员-卡券'
    }
  }, {
    path: '/membergroupDetail',
    component: (0, _import2["default"])('membergroup', 'membergroupDetail'),
    meta: {
      title: '会员分组-详情'
    }
  }, {
    path: '/membertask',
    component: (0, _import2["default"])('membertask', 'membertask'),
    meta: {
      title: '会员任务'
    }
  }, {
    path: '/posmemberDetail',
    // component: _import("wechatmembers", "wechatTotalDetail"),
    redirect: '/customerDetail',
    meta: {
      title: 'pos会员-详情',
      channel: 'posMember'
    }
  }, {
    path: '/wechatmemberDetail',
    // component: _import("wechatmembers", "wechatTotalDetail"),
    redirect: '/customerDetail',
    meta: {
      title: '微信会员-详情',
      channel: 'wxMember'
    }
  }, {
    path: '/wechatTotalDetail',
    // component: _import("wechatmembers", "wechatTotalDetail"),
    redirect: '/customerDetail',
    meta: {
      title: '微信总量-详情'
    }
  }, {
    path: '/integralDataPage',
    component: (0, _import2["default"])('wechatmembers', 'integralDataPage'),
    meta: {
      title: '微信会员-积分明细'
    }
  }, {
    path: '/storedValue',
    component: (0, _import2["default"])('wechatmembers', 'storedValue'),
    meta: {
      title: '微信会员-储值明细'
    }
  }, {
    path: '/modifyintegral',
    component: (0, _import2["default"])('wechatmembers', 'modifyintegral'),
    meta: {
      title: '微信会员-积分调整'
    }
  }, {
    path: '/ajaxmembersinfo',
    component: (0, _import2["default"])('wechatmembers', 'ajaxmembersinfo'),
    meta: {
      title: '微信会员-会员门店消费'
    }
  }, {
    path: '/bulkIntegral',
    name: '/bulkIntegral',
    component: (0, _import2["default"])('wechatmembers', 'bulkIntegral'),
    meta: {
      title: '批量导入',
      keepAlive: true
    }
  }, {
    path: '/bulkLogsDetail',
    name: '/bulkLogsDetail',
    component: (0, _import2["default"])('wechatmembers', 'bulkLogsDetail'),
    meta: {
      title: '日志详情'
    }
  }, {
    path: '/photo-album',
    name: '/photo-album',
    component: (0, _import2["default"])('photo-album', 'album'),
    meta: {
      title: '相册'
    }
  }, {
    path: '/img-list',
    name: '/img-list',
    component: (0, _import2["default"])('photo-album', 'img-list')
  }, {
    path: '/abnormal-member',
    name: '/abnormal-member',
    component: (0, _import2["default"])('wechatmembers', 'abnormal-member'),
    meta: {
      title: '异常会员列表'
    }
  }, {
    path: '/abnormal-member-option',
    name: '/abnormal-member-option',
    component: (0, _import2["default"])('wechatmembers', 'abnormal-member-option'),
    meta: {
      title: '异常会员'
    }
  }, {
    path: '/wmDetail',
    name: '/wmDetail',
    component: (0, _import2["default"])('wechatmembers', 'wmDetail'),
    meta: {
      title: '微盟订单'
    }
  }, {
    path: '/otherDetail',
    name: '/otherDetail',
    component: (0, _import2["default"])('wechatmembers', 'wmDetail'),
    meta: {
      title: '其他订单'
    }
  }, {
    path: '/block-list',
    component: (0, _import2["default"])('block-list', 'index'),
    meta: {
      title: '黑名单列表'
    }
  }, {
    path: '/marketing-record',
    component: (0, _import2["default"])('marketingRecord', 'index'),
    meta: {
      title: '营销记录'
    }
  }]
}];
exports.constantRouterMap = constantRouterMap;
var router = new _vueRouter["default"]({
  // mode: 'history',
  base: '/member/',
  scrollBehavior: function scrollBehavior() {
    return {
      y: 0
    };
  },
  routes: constantRouterMap
});
var _default = router;
exports["default"] = _default;